<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
	"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
    <title>UltraText Terminal UI Library</title>
    <link rel="stylesheet" type="text/css" href="style/default.css" />
    <meta http-equiv="Content-Type" content="text/xhtml+xml; charset=ISO-8859-1" />
</head>
<body>

<div class="banner">
    <h1>UltraText</h1>
    <div class="motto">A terminal UI library</div>
</div>
<hr class="banner" />

<h2><a name="Introduction">Introduction</a></h2>
<p>
This library fills the almost empty niche of user interface frameworks for
text-based terminal applications. While graphical user interfaces have
proliferated dramatically, their terminal equivalents have been largely
left behind, creating a shift to graphical interfaces in pretty much all
applications currently under development. This is rather unfortunate, as
the graphical frameworks are considerably larger and slower. There is also
the concern of being locked in to the continued use of X11, a large beast
by itself, and whatever GUI framework has been chosen. Finally, most
applications do not really need the advanced capabilities of graphical
display and could just as easily be ran from the text console without
launching X at all.
</p><p>
Back in the "good old days" of DOS, there were numerous text-based
applications; word processors, spreadsheets, file managers, finance trackers,
telnet clients, and even games. These applications demonstrated that usable
and attractive interfaces are entirely possible to implement in text mode.
In Linux, things have not gone quite so well. Due to a lack of a decent
terminal output library (curses is not one of those), text mode applications
look and act rather poorly under Linux. Some support only monochrome output,
most accept only alphanumeric keys as input, and all keep a flashing cursor
around even when nothing is focused.
</p><p>
In the UltraText library you will find the necessary tools for creating
beautiful and usable text-mode application in the prevalent visual style
of the last days of DOS. That style is typified by Borland's TurboVision
toolkit, although only a few applications actually used that toolkit. It
features a look similar to what we find in GUIs today; windows, menu bars,
dialogs, interactive input fields and other UI elements.
</p><p>
From a programmer's point of view, I have tried to create an interface
similar to that of Microsoft Foundation Classes, with the document-view
architecture and an event-driven environment that takes care of the
low-level details of output rendering, focus management, event routing,
and error reporting.
</p>

<h2><a name="Installation">Installation</a></h2>
<p>
To start with you'll need a decent compiler. gcc 3.4 or later is required
to compile. Then you'll need to download UltraText and its prerequisites:
<ul>
    <li><a href="https://sourceforge.net/project/showfiles.php?group_id=180992">UltraText</a> - the library itself.</li>
    <li><a href="https://sourceforge.net/project/showfiles.php?group_id=76798">uSTL</a> - a small STL implementation.</li>
    <li><a href="https://sourceforge.net/project/showfiles.php?group_id=142338">Useful Terminal IO</a> - the output backend.</li>
</ul>
After installing uSTL and UTIO, unpack UltraText and run:
</p><pre>
./configure
make install
</pre><p>
configure is not autoconf, but rather a custom program with similar
functionality. <kbd>./configure --help</kbd> lists available options.
You might want to specify a different installation prefix with
<kbd>--prefix=/usr</kbd>; the default destination is /usr/local.
Developers will want to build with <kbd>--with-debug</kbd> to get a lot
of assert error checking, which I highly recommend. If you are the type
to edit configuration manually, it's in Config.mk and config.h.
</p>

<h2><a name="Using">Using it</a></h2>
<p>
Due to the complex nature of user interface specification, it is difficult
to create a simple "hello world" application in a few lines. To get a UI up,
you'll need to create a singleton application object and add at least one
window to the root window. There will eventually be examples showing you
exactly how to do this. For now, the library being still in development,
there is little tutorial documentation. You can look at the doxygen-generated
<a href="html/index.html">class reference</a> and see if you can figure out
how to use it yourself. I am sorry about that.
</p>

<h2><a name="Contact">Bug reporting</a></h2>
<p>
Report bugs through the SourceForge.net UltraText library 
<a href="http://sourceforge.net/projects/utui">project page</a> with the
standard bugtracker.
</p>
<hr />
<div style="align: right;">
    <a href="http://sourceforge.net">
	<img src="http://sourceforge.net/sflogo.php?group_id=180992&amp;type=4"
	    width="127" height="37" alt="Hosted on SourceForge.net" />
    </a> 
    <a href="http://validator.w3.org/check?uri=referer">
	<img src="style/valid-xhtml10.png"
	    height="31" width="88" alt="Valid XHTML 1.0!" />
    </a>
</div>
</body>
</html>

